package org.example.azapi;

//import java.util.Date;
import org.example.azapi.constants.AzDataTypeIdDate;

/**
 * AzAttributeValueDate contains the Java Date object that is intended
 * be used to generate the XACML #date DataType.
 * @author Rich
 *
 */
public interface AzAttributeValueDate 
		extends AzAttributeValue<AzDataTypeIdDate, AzDataDateTime> {
	
	/**
	 * Set the value with Java Date object that will be used to provide the
	 * content for the Xacml DataType: #date
	 * 
	 * @see org.example.azapi.constants.AzDataTypeIdDate
	 * @param date		the Date object intended to be converted to Xacml date
	 */
	public void setValue(AzDataDateTime date);
	
	/**
	 * Return the Date object that is used to produce the Xacml date
	 * DataType content.
	 * 
	 * @return    the Date object             
	 */
	public AzDataDateTime getValue();
	
	/**
	 * Return a String containing the content to be used for a Xacml date DataType.
	 * 
	 * @see       org.example.azapi.constants.AzDataTypeIdDate
	 * @return    a String w content conforming to Xacml DataType: date
	 */
	public String toXacmlString();}
