package org.example.azapi;
import org.example.azapi.constants.AzDataTypeIdDayTimeDuration;

/**
 * AzAttributeValueDayTimeDuration contains AzDataDayTimeDuration
 * object that may be used to generate the XACML 
 * #dayTimeDuration DataType.
 * @author Rich
 */
public interface AzAttributeValueDayTimeDuration 
		extends AzAttributeValue<AzDataTypeIdDayTimeDuration, AzDataDayTimeDuration> {
	
	/**
	 * Set the value of this AzAttributeValueDayTimeDuration object
	 * with an AzDataDayTimeDuration object that can generate the 
	 * string that can be used for the value of a XACML 
	 * #dayTimeDuration DataType.
	 * 
	 * @param azDayTimeDuration that can be used to generate XACML 
	 * #dayTimeDuration DataType
	 */
	public void setValue(AzDataDayTimeDuration azDayTimeDuration);
	
	/**
	 * Return the AzDataDayTimeDuration object that is used by this 
	 * AzAttributeValueDayTimeDuration object to represent the 
	 * XACML #dayTimeDuration DataType  
	 * 
	 * @return  an azDataDayTimeDuration object that corresponds to 
	 * the XACML #dayTimeDuration DataType
	 */
	public AzDataDayTimeDuration getValue();
	
	/**
	 * Return the Java String that can be used as the XACML 
	 * #dayTimeDuration DataType representation of the 
	 * AzDataDayTimeDuration object contained in
	 * this AzAttributeValueDayTimeDuration object.
	 * 
	 * @return	a string that can be used as XACML #dayTimeDuration 
	 * DataType content
	 * 
	 */
	public String toXacmlString();
}
