package org.example.azapi;
import org.example.azapi.constants.AzDataTypeIdIpAddress;

/**
 * AzAttributeValueIpAddress contains Java String object 
 * that may be used to generate the XACML #ipAddress DataType.
 * @author Rich
 */
public interface AzAttributeValueIpAddress 
		extends AzAttributeValue<AzDataTypeIdIpAddress, String> {
	
	/**
	 * Set the value of this AzAttributeValueIpAddress object
	 * with a Java String object that can generate the 
	 * string that can be used for the value of a XACML 
	 * #ipAddress DataType.
	 * 
	 * @param ipAddress a string that can be used to generate XACML 
	 * #ipAddress DataType
	 */
	public void setValue(String ipAddress);
	
	/**
	 * Return the Java String object that is used by this 
	 * AzAttributeValueIpAddress object to represent the 
	 * XACML #ipAddress DataType  
	 * 
	 * @return  a Java String object that corresponds to the 
	 * XACML #ipAddress DataType
	 */
	public String getValue();
	
	/**
	 * Return the Java String that can be used as the XACML #ipAddress
	 * DataType representation of the Java String object 
	 * contained in this AzAttributeValueIpAddress object.
	 * 
	 * @return	a string that can be used as XACML #ipAddress 
	 * DataType content
	 * 
	 */
	public String toXacmlString();
}
