package org.example.azapi;
//import java.util.Date;
import org.example.azapi.constants.AzDataTypeIdTime;

/**
 * AzAttributeValueDate contains the Java Date object within an
 * AzDataDateTime object that contains the information to
 * be used to generate the XACML #date DataType.
 * @author Rich
 *
 */
public interface AzAttributeValueTime 
		extends AzAttributeValue<AzDataTypeIdTime, AzDataDateTime> {
	
	/**
	 * Set the value with an AzDataDateTime object that will be used to provide the
	 * content for the Xacml DataType: #time
	 * 
	 * @see org.example.azapi.constants.AzDataTypeIdTime
	 * @param azDataDateTime an object containing the Date and other 
	 * info to be converted to Xacml #time
	 */
	public void setValue(AzDataDateTime azDataDateTime);
	
	/**
	 * Return the Date object that is used to produce the Xacml date
	 * DataType content.
	 * 
	 * @return    the Date object             
	 */
	public AzDataDateTime getValue();
	
	/**
	 * Return a String containing the content to be used for a 
	 * Xacml #time DataType.
	 * 
	 * @see       org.example.azapi.constants.AzDataTypeIdTime
	 * @return    a String w content conforming to Xacml 
	 * DataType: #time
	 */
	public String toXacmlString();}
