package org.example.azapi;

/**
 * Helper interface to collect the parameters needed to create
 * a XACML #dayTimeDuration DataType
 * @author rlevinson
 *
 */
public interface AzDataDayTimeDuration {
	
	/**
	 * Set boolean indicating whether duration is positive or
	 * negative
	 * @param b true means negative, false means positive
	 */
	public void setNegativeDuration(boolean b);
	
	/**
	 * Get boolean indicating whether duration is positive or
	 * negative
	 * @return a boolean true if negative, false if positive
	 */
	public boolean getNegativeDuration();

	/**
	 * Set long indicating number of days in duration
	 * @param intLong integer number of day in duration
	 */
	public void setDaysInDuration(long intLong);
	
	/**
	 * Get long indicating number of days in duration
	 * @return a long w integer specifying number of days
	 */
	public long getDaysInDuration();

	/**
	 * Set long indicating number of hours in duration
	 * @param intLong integer number of hours in duration
	 */
	public void setHoursInDuration(long intLong);
	
	/**
	 * Get long indicating number of hours in duration
	 * @return a long w integer specifying number of hours
	 */
	public long getHoursInDuration();
	
	/**
	 * Set long indicating number of minutes in duration
	 * @param intLong integer number of minutes in duration
	 */
	public void setMinutesInDuration(long intLong);
	
	/**
	 * Get long indicating number of minutes in duration
	 * @return a long w integer specifying number of minutes
	 */
	public long getMinutesInDuration();
	
	/**
	 * Set long indicating number of seconds in duration
	 * @param intLong integer number of seconds in duration
	 */
	public void setSecondsInDuration(long intLong);
	
	/**
	 * Get long indicating number of seconds in duration
	 * @return a long w integer specifying number of seconds
	 */
	public long getSecondsInDuration();
	
	/**
	 * Set long indicating number of nanoseconds in duration
	 * @param intInt integer number of nanoseconds in duration
	 */
	public void setNanoSecondsInDuration(int intInt);
	
	/**
	 * Get inr indicating number of nanoseconds in duration
	 * @return a long w integer specifying number of nanoseconds
	 */
	public int getNanoSecondsInDuration();
}
