package org.example.azapi;

/**
 * Helper interface to store the parameters needed to create
 * a XACML #yearMonthDuration DataType
 * @author rlevinson
 *
 */
public interface AzDataYearMonthDuration {

	
	/**
	 * Set boolean indicating whether duration is positive or
	 * negative
	 * @param b true means negative, false means positive
	 */
	public void setNegativeDuration(boolean b);
	
	/**
	 * Get boolean indicating whether duration is positive or
	 * negative
	 * @return a boolean true if negative, false if positive
	 */
	public boolean getNegativeDuration();

	/**
	 * Set long indicating number of days in duration
	 * @param intLong integer number of day in duration
	 */
	public void setYearsInDuration(long intLong);
	
	/**
	 * Get long indicating number of years in duration
	 * @return a long w integer specifying number of years
	 */
	public long getYearsInDuration();

	/**
	 * Set long indicating number of years in duration
	 * @param intLong integer number of years in duration
	 */
	public void setMonthsInDuration(long intLong);
	
	/**
	 * Get long indicating number of months in duration
	 * @return a long w integer specifying number of months
	 */
	public long getMonthsInDuration();
	}
