package org.example.azapi.constants;

public enum AzDataTypeIdIpAddress implements AzDataTypeId {
	/** XACML DataType:  <b>urn:oasis:names:tc:xacml:2.0:data-type:ipAddress</b>. 
	 * <br>The urn:oasis:names:tc:xacml:2.0:data-type:ipAddress primitive 
	 * type represents an IPv4 or IPv6 network address, with optional mask 
	 * and optional port or port range. The syntax SHALL be:
	 * <pre>
	 *     ipAddress = address [ "/" mask ] [ ":" [ portrange ] ]
	 * </pre>
	 * For an IPv4 address, the address and mask are formatted in accordance 
	 * with the syntax for a "host" in IETF RFC 2396 "Uniform Resource Identifiers 
	 * (URI): Generic Syntax", section 3.2. 
	 * <p>
	 * For an IPv6 address, the address and mask are formatted in accordance with 
	 * the syntax for an "ipv6reference" in IETF RFC 2732 "Format for Literal IPv6 
	 * Addresses in URL's". (Note that an IPv6 address or mask, in this syntax, 
	 * is enclosed in literal "[" "]" brackets.) 
	 */ 
	AZ_DATATYPE_ID_IPADDRESS("urn:oasis:names:tc:xacml:2.0:data-type:ipAddress");
	private final String azDataTypeId;

	AzDataTypeIdIpAddress(String azDataTypeId) {
		this.azDataTypeId = azDataTypeId;
	}

	@Override
	public String toString() {
		return azDataTypeId;
	}
}