package org.example.azapi.constants;

public enum AzStatusCode {
	/** XACML Identifier: <b>urn:oasis:names:tc:xacml:1.0:status:ok</b>. This identifier indicates success. */
	AZ_OK("urn:oasis:names:tc:xacml:1.0:status:ok"),
	/** XACML Identifier: <b>urn:oasis:names:tc:xacml:1.0:status:missing-attribute</b>. This identifier indicates that all the attributes necessary to make a policy decision were not available (see Section 6.16).*/
	AZ_MISSING_ATTRIBUTE("urn:oasis:names:tc:xacml:1.0:status:missing-attribute"),
	/** XACML Identifier: <b>urn:oasis:names:tc:xacml:1.0:status:syntax-error</b>. This identifier indicates that some attribute value contained a syntax error, such as a letter in a numeric field.*/
	AZ_SYNTAX_ERROR("urn:oasis:names:tc:xacml:1.0:status:syntax-error"),
	/** XACML Identifier: <b>urn:oasis:names:tc:xacml:1.0:status:processing-error</b>. This identifier indicates that some attribute value contained a syntax error, such as a letter in a numeric field.*/
	AZ_PROCESSING_ERROR("urn:oasis:names:tc:xacml:1.0:status:processing-error");
	final String azStatusCode;
	AzStatusCode(String azStatusCode){
		this.azStatusCode = azStatusCode;
	}
}
