package org.example.azapi.test;

import java.util.Iterator;
import java.util.Set;

import org.example.azapi.AzService;
//import org.example.azapi.AzEntityOld;
import org.example.azapi.AzRequestContext;
import org.example.azapi.AzResponseContext;

//import org.example.azapi.AzAction;
//import org.example.azapi.AzEnvironment;
//import org.example.azapi.AzResource;
//import org.example.azapi.AzSubject;
//import org.example.azapi.AzResult;
//import org.example.azapi.AzObligations;
//import org.example.azapi.AzObligation;
import org.example.azapi.AzEntity;

//import org.example.azapi.AzActionAttribute;
//import org.example.azapi.AzAttributeValue;
//import org.example.azapi.AzAttributeValueDateTime;
//import org.example.azapi.AzAttributeValueString;
//import org.example.azapi.AzEnvironmentAttribute;
import org.example.azapi.AzResourceActionAssociation;
import org.example.azapi.AzResourceActionAssociationId;
//import org.example.azapi.AzResourceAttribute;
//import org.example.azapi.AzSubjectAttribute;

//import org.example.azapi.constants.AzCategoryIdOld;
//import org.example.azapi.constants.AzActionCategoryId;
import org.example.azapi.constants.AzCategoryIdStatusDetail;
//import org.example.azapi.constants.AzDataTypeId;
import org.example.azapi.constants.AzDataTypeIdString;
//import org.example.azapi.constants.AzEnvironmentCategoryId;
//import org.example.azapi.constants.AzResourceCategoryId;
//import org.example.azapi.constants.AzSubjectCategoryId;
import org.example.azapi.constants.AzCategoryIdObligation;

import org.example.azapi.constants.AzDecision;
import org.example.azapi.constants.AzStatusCode;
import org.example.azapi.util.AzEntityFactory;
//import org.example.azapi.constants.AzXacmlStrings;

//import org.example.azapi.AzAttribute;

public class TestAzService implements AzService {
	public TestAzService(){}
	
	public AzResponseContext decide(AzRequestContext azReqCtx)
	{
		System.out.println("TestAzService.decide(): ");
		// Create a Response Context to store the results
		TestAzResponseContext rspCtx = new TestAzResponseContext();
		
		// Create the first AzResult which must be prepared for
		// return in case there are no AzResourceActionAssociations
		// to process.
		TestAzResult azResult = new TestAzResult();  
		
		AzResourceActionAssociation azAssoc = null;
		AzResourceActionAssociationId azAssocId = null;
		Iterator<AzResourceActionAssociation> it = azReqCtx.getAssociations().iterator();
		if (!it.hasNext()){
			// Set the null AssociationId case to be processing error
			azResult.setAzDecision(AzDecision.AZ_INDETERMINATE);
			azResult.setAzStatusCode(AzStatusCode.AZ_SYNTAX_ERROR);
			azResult.setStatusMessage(TestAzStatusMessages.NO_RESOURCE_ACTION_ASSOCIATION);
			rspCtx.addResult(azResult);
		}
		while (it.hasNext()){
			azAssoc = it.next();
			azAssocId = azAssoc.getAzResourceActionAssociationId();
			System.out.println("\t ResourceId: " + azAssocId.getResourceId() +
					"\t  ActionId: " + azAssocId.getActionId());
			azResult = new TestAzResult();
			azResult.setAzResourceActionAssociation(azAssoc);
			azResult.setAzDecision(getAzDecisionValue());
			azResult.setAzStatusCode(getStatusCode());
			azResult.setStatusMessage(getStatusMessage());
			System.out.println("    TestAzService.decide: " +
					"\n\t getStatusMessage: " + getStatusMessage());
			switch (azResult.getAzDecision()) {
				case AZ_PERMIT:
					TestAzObligations azObligations = new TestAzObligations();
					//TestAzObligation azObligation = new TestAzObligation();
					AzEntity<AzCategoryIdObligation> azObligation = 
						AzEntityFactory.getAzEntity(AzCategoryIdObligation.AZ_CATEGORY_ID_OBLIGATION);
					//azObligation.createAzAttributeAssignment(
							//null, 		// no category-id for obl attrs
							//AzCategoryId.X_CATEGORY_OBLIGATION,
					azObligation.createAzAttribute(
							"PDP-Issuer", 			 // issuer
							"Obl-attr-id-test-obl",  // attr-id
							azObligation.createAzAttributeValue(
								AzDataTypeIdString.AZ_DATATYPE_ID_STRING,
								"PEP is obligated to roll out the red carpet"));
					//azObligation.createAzAttributeAssignment(
							//null, 		// no category-id for obl attrs
							//AzCategoryId.X_CATEGORY_OBLIGATION,
					azObligation.createAzAttribute(
							"PDP-Issuer", 			 // issuer
							"Obl-attr-id-test-obl-2",  // attr-id
							azObligation.createAzAttributeValue(
								AzDataTypeIdString.AZ_DATATYPE_ID_STRING,
								"PEP is obligated to roll out the green carpet, too"));
					azObligations.addAzObligation(azObligation);
					azResult.setAzObligations(azObligations);
					//Iterator<AzObligation> itOb = azResult.getAzObligations().iterator();
					Iterator<AzEntity<AzCategoryIdObligation>> itOb = azResult.getAzObligations().iterator();
					System.out.println("TestAzService.decide: check itOb.hasNext() = " + itOb.hasNext());
					break;
				case AZ_DENY:
					//TBD: put a test case for Deny here.
					break;
				case AZ_NOTAPPLICABLE:
					//TBD: put a test case for NotApplicable here.
					break;
				case AZ_INDETERMINATE:
					switch (azResult.getAzStatusCode()){
						case AZ_SYNTAX_ERROR:
							// TBD: put a test case for Indeterminate.SyntaxError here.
							break;
						case AZ_PROCESSING_ERROR:
							//TBD: put a test case for Indeterminate.ProcessingError here.
							break;
						case AZ_MISSING_ATTRIBUTE:
							//TestAzStatusDetail azStatusDetail =
							//	new TestAzStatusDetail();
							AzEntity<AzCategoryIdStatusDetail> azStatusDetail =
								AzEntityFactory.getAzEntity(
									AzCategoryIdStatusDetail.AZ_CATEGORY_ID_STATUSDETAIL);
							//azStatusDetail.addAzMissingAttributeDetail(
							azStatusDetail.createAzAttribute(
								//new TestAzMissingAttributeDetail(
									//AzCategoryIdOld.X_CATEGORY_MISSING_ATTRIBUTE_DETAIL,
									"PDP-issuer",
									"MissingAttribute-01-AttributeId",
									azStatusDetail.createAzAttributeValue(
										AzDataTypeIdString.AZ_DATATYPE_ID_STRING,
										"This is the value needed for this missing attribute"));
							azResult.setAzStatusDetail(azStatusDetail);
							break;
					}					
			}			
			rspCtx.addResult(azResult);
		}		
		return rspCtx;
	}
	
	/**
	 * Dummy PDP to return a mix of AzDecisions.
	 * No need to make public.
	 */
	int counter = 0;
	AzDecision getAzDecisionValue(){
		counter++;
		System.out.println("TestAzService: counter = " + counter);
		int modCtr = counter % 6;
		switch (modCtr){
			case(1): return AzDecision.AZ_PERMIT;
			case(2): return AzDecision.AZ_NOTAPPLICABLE;
			case(3): return AzDecision.AZ_INDETERMINATE;
			case(4): return AzDecision.AZ_INDETERMINATE;
			case(5): return AzDecision.AZ_INDETERMINATE;
		}
		return AzDecision.AZ_DENY;
	}
	String getStatusMessage() {
		String statMsg = null;
		int modCtr = counter % 6;
		switch (modCtr){
			case(0): return statMsg = TestAzStatusMessages.AZMSG_DENY; 
			case(1): return statMsg = TestAzStatusMessages.AZMSG_PERMIT; 
			case(2): return statMsg = TestAzStatusMessages.AZMSG_NOTAPPLICABLE;
			case(3): return statMsg = TestAzStatusMessages.AZMSG_INDETERMINATE_MISSING_ATTR;
			case(4): return statMsg = TestAzStatusMessages.AZMSG_INDETERMINATE_SYNTAX_ERROR;
			case(5): return statMsg = TestAzStatusMessages.AZMSG_INDETERMINATE_PROCESSING_ERROR;
		}
		return statMsg;
	}
	AzStatusCode getStatusCode() {
		int modCtr = counter % 6;
		switch (modCtr){
			case(1): return AzStatusCode.AZ_OK;
			case(2): return AzStatusCode.AZ_OK;
			case(3): return AzStatusCode.AZ_MISSING_ATTRIBUTE;
			case(4): return AzStatusCode.AZ_PROCESSING_ERROR;
			case(5): return AzStatusCode.AZ_SYNTAX_ERROR;		
		}
		return AzStatusCode.AZ_OK;
	}
	
	//public Set<AzResourceActionAssociation> whatIsAllowed(String resourceExpression, AzRequestContext azRequestContext){
	//	Set<AzResourceActionAssociation> azResActAssoc = null;
	//	return azResActAssoc;
	//}
	
	/**
	 * Returns the set of AzResourceActionAssociations that are allowed on the specified
	 * input AzResource.
	 * 
	 * @param azResource
	 * @param azRequestContext only the AzEnvironment and AzSubject entities will be 
	 * considered in the evaluation 
	 * @return
	 */
	//public Set<AzResourceActionAssociation> whatIsAllowed(AzResource azResource, AzRequestContext azRequestContext){
	//	Set<AzResourceActionAssociation> azResActAssoc = null;
	//	return azResActAssoc;
	//}
	
	public Set<AzResourceActionAssociation> query(
			String scope, AzRequestContext azRequestContext,
			boolean allowedNotAllowed){
		Set<AzResourceActionAssociation> azResActAssoc = null;
		return azResActAssoc;
	}
	
	public AzResponseContext queryVerbose(
			String scope, AzRequestContext azRequestContext){
		AzResponseContext azRespContext = null;
		return azRespContext;
	}

	public AzRequestContext createAzRequestContext(){
		AzRequestContext reqCtx = new TestAzRequestContext();
		return reqCtx;
	}
	/*
	public AzEntityOld createAzEntity(AzCategoryIdOld c){
		if (c == AzActionCategoryId.X_CATEGORY_ACTION)
			return new TestAzActionOld();
		else if (c == AzEnvironmentCategoryId.X_CATEGORY_ENVIRONMENT)
			return new TestAzEnvironment();
		else if (c == AzResourceCategoryId.X_CATEGORY_RESOURCE)
			return new TestAzResource();
		else return new TestAzSubject((AzSubjectCategoryId)c);
	}
	*/
}
